// RSSMU_Multi_Carrier_CW_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMU_Multi_Carrier_CW_Example.h"
#include "RSSMU_Multi_Carrier_CW_ExampleDlg.h"
#include "Resource.h"
#include "rssmu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_Multi_Carrier_CW_ExampleDlg dialog

CRSSMU_Multi_Carrier_CW_ExampleDlg::CRSSMU_Multi_Carrier_CW_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMU_Multi_Carrier_CW_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMU_Multi_Carrier_CW_ExampleDlg)
	m_CarrierSpacing = 1000.0;
	m_Query = TRUE;
	m_CWState = FALSE;
	m_NumberOfCarriers = 64;
	m_Reset = TRUE;
	m_ResName = _T("GPIB::28");
	m_RFFreq = 1.0e9;
	m_RFLevel = -30.0;
	m_RFState = FALSE;
	m_OptimCrestFactor = 1;
	m_DesiredCRestFactor = 3.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMU_Multi_Carrier_CW_ExampleDlg)
	DDX_Text(pDX, IDC_CARRER_SPACING, m_CarrierSpacing);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_Check(pDX, IDC_MULTI_CW_STATE, m_CWState);
	DDX_Text(pDX, IDC_NUMBER_OF_CARRIERS, m_NumberOfCarriers);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	DDX_CBIndex(pDX, IDC_OPTIM_CREST_FACTOR, m_OptimCrestFactor);
	DDX_Text(pDX, IDC_DESIRED_CREST_FACTOR, m_DesiredCRestFactor);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMU_Multi_Carrier_CW_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMU_Multi_Carrier_CW_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDAPPLY, OnApply)
	ON_CBN_SELCHANGE(IDC_OPTIM_CREST_FACTOR, OnSelchangeOptimCrestFactor)
	ON_EN_KILLFOCUS(IDC_CARRER_SPACING, OnKillfocusCarrerSpacing)
	ON_EN_KILLFOCUS(IDC_DESIRED_CREST_FACTOR, OnKillfocusDesiredCrestFactor)
	ON_EN_KILLFOCUS(IDC_NUMBER_OF_CARRIERS, OnKillfocusNumberOfCarriers)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_Multi_Carrier_CW_ExampleDlg message handlers

BOOL CRSSMU_Multi_Carrier_CW_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CWnd*	pdlg_item;
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	pdlg_item = GetDlgItem(IDC_DESIRED_CREST_FACTOR);
	pdlg_item->EnableWindow(m_OptimCrestFactor == 2); 
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMU_Multi_Carrier_CW_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnApply() 
{
	ViStatus	rssmu_status;
	ViSession	instrSession;
	ViInt32		CrestFactorModeArr[] = {RSSMU_MCCW_CREST_FACTOR_MODE_OFF,RSSMU_MCCW_CREST_FACTOR_MODE_CHIRP,RSSMU_MCCW_CREST_FACTOR_MODE_SLOW};
	char		buffer[512];
	CString		str;
	
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	UpdateData();

    /* Initialize the driver */
	rssmu_status = rssmu_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rssmu_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}

	FT_CHECKERR (rssmu_SetMCCWNoofCarriers (instrSession, RSSMU_PATH_A, m_NumberOfCarriers), "rssmu_SetMCCWNoofCarriers");
	FT_CHECKERR (rssmu_SetMCCWCarrierSpacing (instrSession, RSSMU_PATH_A, m_CarrierSpacing), "rssmu_SetMCCWCarrierSpacing");
	FT_CHECKERR (rssmu_SetMCCWOptimizeCrestFactorMode (instrSession, RSSMU_PATH_A, CrestFactorModeArr[m_OptimCrestFactor]), "rssmu_SetMCCWOptimizeCrestFactorMode");
	if (m_OptimCrestFactor == 2)
	{
/*		m_DesiredCrestFactor.GetWindowText(str);
		double DesiredCF = atof(str);

		DesiredCF = __min(DesiredCF, 100.0);
		DesiredCF = __max(DesiredCF, 0.0);
*/
		FT_CHECKERR (rssmu_SetMCCWDesiredCrestFactor (instrSession , RSSMU_PATH_A, m_DesiredCRestFactor), "rssmu_SetMCCWDesiredCrestFactor");
	}
	
	FT_CHECKERR (rssmu_SetMCCWState (instrSession, RSSMU_PATH_A, m_CWState), "rssmu_SetMCCWState");

	FT_CHECKERR (rssmu_SetRFAmplitude (instrSession, RSSMU_PATH_A, m_RFLevel), "rssmu_SetRFAmplitude");
	FT_CHECKERR (rssmu_SetRFFrequency (instrSession, RSSMU_PATH_A, m_RFFreq), "rssmu_SetRFFrequency");
	FT_CHECKERR (rssmu_SetOutputState (instrSession, RSSMU_PATH_A, m_RFState), "rssmu_SetOutputState");
	rssmu_close(instrSession);
	
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnSelchangeOptimCrestFactor() 
{
	UpdateData();
	CWnd*	pdlg_item;	
	
	pdlg_item = GetDlgItem(IDC_DESIRED_CREST_FACTOR);
	pdlg_item->EnableWindow(m_OptimCrestFactor == 2); 
		
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnKillfocusCarrerSpacing() 
{
	// TODO: Add your control notification handler code here
	double	min;
	double	max;
	CString message;

	min = 0.0;
    max = 50000000.0;
	
	UpdateData(TRUE);
	if ((m_CarrierSpacing <min) || (m_CarrierSpacing >max))
	{
		message.Format("Please enter value in range %.1lf to %.1lf!",min,max);
		AfxMessageBox (message, MB_OK);
		m_CarrierSpacing = min;
		UpdateData(FALSE);
	}	
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnKillfocusDesiredCrestFactor() 
{
	// TODO: Add your control notification handler code here
	double	min;
	double	max;
	CString message;

	min = 0;
    max = 100;
	
	UpdateData(TRUE);
	if ((m_DesiredCRestFactor <min) || (m_DesiredCRestFactor >max))
	{
		message.Format("Please enter value in range %.1lf to %.1lf!",min,max);
		AfxMessageBox (message, MB_OK);
		m_DesiredCRestFactor = min;
		UpdateData(FALSE);
	}		
}

void CRSSMU_Multi_Carrier_CW_ExampleDlg::OnKillfocusNumberOfCarriers() 
{
	// TODO: Add your control notification handler code here
	long	min;
	long	max;
	CString message;

	min = 1;
    max = 8192;
	
	UpdateData(TRUE);
	if ((m_NumberOfCarriers <min) || (m_NumberOfCarriers >max))
	{
		message.Format("Please enter value in range %ld to %ld!",min,max);
		AfxMessageBox (message, MB_OK);
		m_NumberOfCarriers = min;
		UpdateData(FALSE);
	}	
}


